<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>CppUtils xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/components/transformation/cpp/xtend/CppUtils.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.components.transformation.cpp.xtend;
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <strong class="jxr_keyword">import</strong> com.google.common.base.Objects;
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Ptr;
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.StereotypeUtil;
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.AggregationKind;
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   @SuppressWarnings(<span class="jxr_string">"all"</span>)
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/cpp/xtend/CppUtils.html">CppUtils</a> {
<a class="jxr_linenumber" name="L11" href="#L11">11</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String nameRef(<strong class="jxr_keyword">final</strong> Property part) {
<a class="jxr_linenumber" name="L12" href="#L12">12</a>      String _name = part.getName();
<a class="jxr_linenumber" name="L13" href="#L13">13</a>      String _refOp = CppUtils.refOp(part);
<a class="jxr_linenumber" name="L14" href="#L14">14</a>      <strong class="jxr_keyword">return</strong> (_name + _refOp);
<a class="jxr_linenumber" name="L15" href="#L15">15</a>    }
<a class="jxr_linenumber" name="L16" href="#L16">16</a>    
<a class="jxr_linenumber" name="L17" href="#L17">17</a>    <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <em class="jxr_javadoccomment">   * return the operator for (de-) referencing a part. If the part is</em>
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <em class="jxr_javadoccomment">   * instantiate via the bootloader, it becomes a pointer. If it is</em>
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <em class="jxr_javadoccomment">   * instantiated by the composite itself, it is not a pointer, it will be</em>
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <em class="jxr_javadoccomment">   * instantiated along with the composite</em>
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <em class="jxr_javadoccomment">   * </em>
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <em class="jxr_javadoccomment">   * @param part</em>
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <em class="jxr_javadoccomment">   * @return</em>
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <em class="jxr_javadoccomment">   */</em>
<a class="jxr_linenumber" name="L26" href="#L26">26</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String refOp(<strong class="jxr_keyword">final</strong> Property part) {
<a class="jxr_linenumber" name="L27" href="#L27">27</a>      String _xifexpression = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>      <strong class="jxr_keyword">boolean</strong> _or = false;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>      AggregationKind _aggregation = part.getAggregation();
<a class="jxr_linenumber" name="L30" href="#L30">30</a>      <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(_aggregation, AggregationKind.SHARED_LITERAL);
<a class="jxr_linenumber" name="L31" href="#L31">31</a>      <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L32" href="#L32">32</a>        _or = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>      } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L34" href="#L34">34</a>        <strong class="jxr_keyword">boolean</strong> _isApplied = StereotypeUtil.isApplied(part, Ptr.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L35" href="#L35">35</a>        _or = _isApplied;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>      }
<a class="jxr_linenumber" name="L37" href="#L37">37</a>      <strong class="jxr_keyword">if</strong> (_or) {
<a class="jxr_linenumber" name="L38" href="#L38">38</a>        _xifexpression = <span class="jxr_string">"-&gt;"</span>;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>      } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L40" href="#L40">40</a>        _xifexpression = <span class="jxr_string">"."</span>;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>      }
<a class="jxr_linenumber" name="L42" href="#L42">42</a>      <strong class="jxr_keyword">return</strong> _xifexpression;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>    }
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
